Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jetty.server
Class ServletRequestHttpWrapper

    java.lang.Object
      javax.servlet.ServletRequestWrapper
          org.eclipse.jetty.server.ServletRequestHttpWrapper

All Implemented Interfaces:
  HttpServletRequest, ServletRequest

    public class ServletRequestHttpWrapper

extends ServletRequestWrapper
implements HttpServletRequest

Class to tunnel a ServletRequest via a HttpServletRequest

Field Summary

Fields inherited from interface javax.servlet.http.HttpServletRequest
`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

Constructor Summary
`ServletRequestHttpWrapper(ServletRequest request)`

Method Summary
`boolean` | `authenticate(HttpServletResponse response)` Use the container login mechanism configured for the `ServletContext` to authenticate the user making this request.
`java.lang.String` | `getAuthType()` Returns the name of the authentication scheme used to protect the servlet.
`java.lang.String` | `getContextPath()` Returns the portion of the request URI that indicates the context of the request.
`Cookie[]` | `getCookies()` Returns an array containing all of the `Cookie` objects the client sent with this request.
`long` | `getDateHeader(java.lang.String name)` Returns the value of the specified request header as a `long` value that represents a `Date` object.
`java.lang.String` | `getHeader(java.lang.String name)` Returns the value of the specified request header as a `String`.
`java.util.Enumeration` | `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`java.util.Enumeration` | `getHeaders(java.lang.String name)` Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`int` | `getIntHeader(java.lang.String name)` Returns the value of the specified request header as an `int`.
`java.lang.String` | `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`Part` | `getPart(java.lang.String name)` Gets the `Part` with the given name.
`java.util.Collection<Part>` | `getParts()` Gets all the `Part` components of this request, provided that it is of type `multipart/form-data`.
`java.lang.String` | `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`java.lang.String` | `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`java.lang.String` | `getQueryString()` Returns the query string that is contained in the request URL after the path.
`java.lang.String` | `getRemoteUser()` Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`java.lang.String` | `getRequestedSessionId()` Returns the session ID specified by the client.
`java.lang.String` | `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`java.lang.StringBuffer` | `getRequestURL()` Reconstructs the URL the client used to make the request.
`java.lang.String` | `getServletPath()` Returns the part of this request's URL that calls the servlet.
`HttpSession` | `getSession()` Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession` | `getSession(boolean create)` Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.
`java.security.Principal` | `getUserPrincipal()` Returns a `java.security.Principal` object containing the name of the current authenticated user.
`boolean` | `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` | `isRequestedSessionIdFromUrl()`
`boolean` | `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`boolean` | `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`boolean` | `isUserInRole(java.lang.String role)` Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
`void` | `login(java.lang.String username, java.lang.String password)` Validate the provided username and password in the password validation realm used by the web container login mechanism configured for the `ServletContext`.
`void` | `logout()` Establish `null` as the value returned when `getUserPrincipal`, `getRemoteUser`, and `getAuthType` is called on the request.

Methods inherited from class javax.servlet.ServletRequestWrapper
`getAsyncContext, getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentType, getDispatcherType, getInputStream, getLocalAddr, getLocale, getLocales, getLocalName, getLocalPort, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRemotePort, getRequest, getRequestDispatcher, getScheme, getServerName, getServerPort, getServletContext, isAsyncStarted, isAsyncSupported, isSecure, isWrapperFor, isWrapperFor, removeAttribute, setAttribute, setCharacterEncoding, setRequest, startAsync, startAsync`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.servlet.ServletRequest
`getAsyncContext, getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentType, getDispatcherType, getInputStream, getLocalAddr, getLocale, getLocales, getLocalName, getLocalPort, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRemotePort, getRequestDispatcher, getScheme, getServerName, getServerPort, getServletContext, isAsyncStarted, isAsyncSupported, isSecure, removeAttribute, setAttribute, setCharacterEncoding, startAsync, startAsync`

Constructor Detail

### ServletRequestHttpWrapper

    public ServletRequestHttpWrapper(ServletRequest request)

Method Detail

### getAuthType

    public java.lang.String getAuthType()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the authentication scheme used to protect the servlet. All servlet containers support basic, form and client certificate authentication, and may additionally support digest authentication. If the servlet is not authenticated `null` is returned.

  Same as the value of the CGI variable AUTH_TYPE.

  Specified by:
    `getAuthType` in interface `HttpServletRequest`
  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

### getCookies

    public Cookie[] getCookies()

  Description copied from interface: `HttpServletRequest`
  Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.

  Specified by:
    `getCookies` in interface `HttpServletRequest`
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getDateHeader

    public long getDateHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `long` value that represents a `Date` object. Use this method with headers that contain dates, such as `If-Modified-Since`.

  The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

  If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an `IllegalArgumentException`.

  Specified by:
    `getDateHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the request

### getHeader

    public java.lang.String getHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. If there are multiple headers with the same name, this method returns the first head in the request. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaders

    public java.util.Enumeration getHeaders(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns all the values of the specified request header as an `Enumeration` of `String` objects.

  Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

  If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeaders` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getHeaderNames

    public java.util.Enumeration getHeaderNames()

  Description copied from interface: `HttpServletRequest`
  Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

  Some servlet containers do not allow servlets to access headers using this method, in which case this method returns `null`

  Specified by:
    `getHeaderNames` in interface `HttpServletRequest`
  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getIntHeader

    public int getIntHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

  The header name is case insensitive.

  Specified by:
    `getIntHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name

### getMethod

    public java.lang.String getMethod()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

  Specified by:
    `getMethod` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the name of the method with which this request was made

### getPathInfo

    public java.lang.String getPathInfo()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string and will start with a "/" character.

  This method returns `null` if there was no extra path information.

  Same as the value of the CGI variable PATH_INFO.

  Specified by:
    `getPathInfo` in interface `HttpServletRequest`
  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

    public java.lang.String getPathTranslated()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

  If the URL does not have any extra path information, this method returns `null` or the servlet container cannot translate the virtual path to a real path for any reason (such as when the web application is executed from an archive). The web container does not decode this string.

  Specified by:
    `getPathTranslated` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getContextPath

    public java.lang.String getContextPath()

  Description copied from interface: `HttpServletRequest`
  Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.

  It is possible that a servlet container may match a context by more than one context path. In such cases this method will return the actual context path used by the request and it may differ from the path returned by the `ServletContext.getContextPath()` method. The context path returned by `ServletContext.getContextPath()` should be considered as the prime or preferred context path of the application.

  Specified by:
    `getContextPath` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request
  See Also:
    `ServletContext.getContextPath()`

### getQueryString

    public java.lang.String getQueryString()

  Description copied from interface: `HttpServletRequest`
  Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

  Specified by:
    `getQueryString` in interface `HttpServletRequest`
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getRemoteUser

    public java.lang.String getRemoteUser()

  Description copied from interface: `HttpServletRequest`
  Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

  Specified by:
    `getRemoteUser` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the login of the user making this request, or `null` if the user login is not known

### isUserInRole

    public boolean isUserInRole(java.lang.String role)

  Description copied from interface: `HttpServletRequest`
  Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.

  Specified by:
    `isUserInRole` in interface `HttpServletRequest`
  Parameters:
    `role` - a `String` specifying the name of the role
  Returns:
    a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

### getUserPrincipal

    public java.security.Principal getUserPrincipal()

  Description copied from interface: `HttpServletRequest`
  Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.

  Specified by:
    `getUserPrincipal` in interface `HttpServletRequest`
  Returns:
    a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

### getRequestedSessionId

    public java.lang.String getRequestedSessionId()

  Description copied from interface: `HttpServletRequest`
  Returns the session ID specified by the client. This may not be the same as the ID of the current valid session for this request. If the client did not specify a session ID, this method returns `null`.

  Specified by:
    `getRequestedSessionId` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the session ID, or `null` if the request did not specify a session ID
  See Also:
    `HttpServletRequest.isRequestedSessionIdValid()`

### getRequestURI

    public java.lang.String getRequestURI()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

  First line of HTTP request | Returned Value
  --- | ---
  POST /some/path.html HTTP/1.1 |  | /some/path.html
  GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
  HEAD /xyz?a=b HTTP/1.1 |  | /xyz

  To reconstruct an URL with a scheme and host, use `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`.

  Specified by:
    `getRequestURI` in interface `HttpServletRequest`
  Returns:
    a `String` containing the part of the URL from the protocol name up to the query string
  See Also:
    `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

### getRequestURL

    public java.lang.StringBuffer getRequestURL()

  Description copied from interface: `HttpServletRequest`
  Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

  If this request has been forwarded using `RequestDispatcher.forward(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`, the server path in the reconstructed URL must reflect the path used to obtain the RequestDispatcher, and not the server path specified by the client.

  Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

  This method is useful for creating redirect messages and for reporting errors.

  Specified by:
    `getRequestURL` in interface `HttpServletRequest`
  Returns:
    a `StringBuffer` object containing the reconstructed URL

### getServletPath

    public java.lang.String getServletPath()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL that calls the servlet. This path starts with a "/" character and includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.

  This method will return an empty string ("") if the servlet used to process this request was matched using the "/*" pattern.

  Specified by:
    `getServletPath` in interface `HttpServletRequest`
  Returns:
    a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded, or an empty string if the servlet used to process the request is matched using the "/*" pattern.

### getSession

    public HttpSession getSession(boolean create)

  Description copied from interface: `HttpServletRequest`
  Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.

  If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

  To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Parameters:
    `create` - `true` to create a new session for this request if necessary; `false` to return `null` if there's no current session
  Returns:
    the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
  See Also:
    `HttpServletRequest.getSession()`

### getSession

    public HttpSession getSession()

  Description copied from interface: `HttpServletRequest`
  Returns the current session associated with this request, or if the request does not have a session, creates one.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Returns:
    the `HttpSession` associated with this request
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdValid

    public boolean isRequestedSessionIdValid()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID is still valid.

  If the client did not specify any session ID, this method returns `false`.

  Specified by:
    `isRequestedSessionIdValid` in interface `HttpServletRequest`
  Returns:
    `true` if this request has an id for a valid session in the current session context; `false` otherwise
  See Also:
    `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`, `HttpSessionContext`

### isRequestedSessionIdFromCookie

    public boolean isRequestedSessionIdFromCookie()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as a cookie.

  Specified by:
    `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as a cookie; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromURL

    public boolean isRequestedSessionIdFromURL()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as part of the request URL.

  Specified by:
    `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as part of a URL; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromUrl

    public boolean isRequestedSessionIdFromUrl()

  Specified by:
    `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`

### authenticate

    public boolean authenticate(HttpServletResponse response)
                         throws java.io.IOException,
                                ServletException

  Description copied from interface: `HttpServletRequest`
  Use the container login mechanism configured for the `ServletContext` to authenticate the user making this request.

  This method may modify and commit the argument `HttpServletResponse`.

  Specified by:
    `authenticate` in interface `HttpServletRequest`
  Parameters:
    `response` - The `HttpServletResponse` associated with this `HttpServletRequest`
  Returns:
    `true` when non-null values were or have been established as the values returned by `getUserPrincipal`, `getRemoteUser`, and `getAuthType`. Return `false` if authentication is incomplete and the underlying login mechanism has committed, in the response, the message (e.g., challenge) and HTTP status code to be returned to the user.
  Throws:
    `java.io.IOException` - if an input or output error occurred while reading from this request or writing to the given response
    `ServletException` - if the authentication failed and the caller is responsible for handling the error (i.e., the underlying login mechanism did NOT establish the message and HTTP status code to be returned to the user)
  See Also:
    `HttpServletRequest.authenticate(javax.servlet.http.HttpServletResponse)`

### getPart

    public Part getPart(java.lang.String name)
                 throws java.io.IOException,
                        ServletException

  Description copied from interface: `HttpServletRequest`
  Gets the `Part` with the given name.

  Specified by:
    `getPart` in interface `HttpServletRequest`
  Parameters:
    `name` - the name of the requested Part
  Returns:
    The Part with the given name, or `null` if this request is of type `multipart/form-data`, but does not contain the requested Part
  Throws:
    `java.io.IOException` - if an I/O error occurred during the retrieval of the requested Part
    `ServletException` - if this request is not of type `multipart/form-data`
  See Also:
    `HttpServletRequest.getPart(java.lang.String)`

### getParts

    public java.util.Collection<Part> getParts()
                                        throws java.io.IOException,
                                               ServletException

  Description copied from interface: `HttpServletRequest`
  Gets all the `Part` components of this request, provided that it is of type `multipart/form-data`.

  If this request is of type `multipart/form-data`, but does not contain any Part components, the returned `Collection` will be empty.

  Any changes to the returned `Collection` must not affect this `HttpServletRequest`.

  Specified by:
    `getParts` in interface `HttpServletRequest`
  Returns:
    a (possibly empty) `Collection` of the Part components of this request
  Throws:
    `java.io.IOException` - if an I/O error occurred during the retrieval of the `Part` components of this request
    `ServletException` - if this request is not of type `multipart/form-data`
  See Also:
    `HttpServletRequest.getParts()`

### login

    public void login(java.lang.String username,
                      java.lang.String password)
               throws ServletException

  Description copied from interface: `HttpServletRequest`
  Validate the provided username and password in the password validation realm used by the web container login mechanism configured for the `ServletContext`.

  This method returns without throwing a `ServletException` when the login mechanism configured for the `ServletContext` supports username password validation, and when, at the time of the call to login, the identity of the caller of the request had not been established (i.e, all of `getUserPrincipal`, `getRemoteUser`, and `getAuthType` return null), and when validation of the provided credentials is successful. Otherwise, this method throws a `ServletException` as described below.

  When this method returns without throwing an exception, it must have established non-null values as the values returned by `getUserPrincipal`, `getRemoteUser`, and `getAuthType`.

  Specified by:
    `login` in interface `HttpServletRequest`
  Parameters:
    `username` - The `String` value corresponding to the login identifier of the user.
    `password` - The password `String` corresponding to the identified user.
  Throws:
    `ServletException` - if the configured login mechanism does not support username password authentication, or if a non-null caller identity had already been established (prior to the call to login), or if validation of the provided username and password fails.
  See Also:
    `HttpServletRequest.login(java.lang.String, java.lang.String)`

### logout

    public void logout()
                throws ServletException

  Description copied from interface: `HttpServletRequest`
  Establish `null` as the value returned when `getUserPrincipal`, `getRemoteUser`, and `getAuthType` is called on the request.

  Specified by:
    `logout` in interface `HttpServletRequest`
  Throws:
    `ServletException` - if logout fails
  See Also:
    `HttpServletRequest.logout()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.